<?php
namespace Chatwee\Chatwee\Configuration;

use TYPO3\CMS\Core\Utility\GeneralUtility;
use TYPO3\CMS\Extensionmanager\ViewHelpers\Form\TypoScriptConstantsViewHelper;

class ChatweeCodeInput {

    protected $textareaTag = NULL;

    protected $infoTag = NULL;

    public function __construct() {
        $this->textareaTag = GeneralUtility::makeInstance('TYPO3\\CMS\\Fluid\\Core\\ViewHelper\\TagBuilder');
        $this->infoTag = GeneralUtility::makeInstance('TYPO3\\CMS\\Fluid\\Core\\ViewHelper\\TagBuilder');
    }

    public function render(array $parameter = array(), TypoScriptConstantsViewHelper $parentObject) {
        $this->textareaTag->setTagName('textarea');
        $this->textareaTag->forceClosingTag(TRUE);
        $this->textareaTag->addAttribute('style', 'width: 100%;');
        $this->textareaTag->addAttribute('rows', 7);
        $this->textareaTag->addAttribute('name', $parameter['fieldName']);
        $this->textareaTag->addAttribute('id', 'em-' . $parameter['fieldName']);
        if ($parameter['fieldValue'] !== NULL) {
            $this->textareaTag->setContent(trim($parameter['fieldValue']));
        }

        $this->infoTag->setTagName('div');
        $this->infoTag->setContent('Copy the Chatwee installation code from your <a target="_blank" style="text-decoration: underline;" href="https://client.chatwee.com/v2/dashboard/index"><b>Chatwee Client Panel</b></a> and paste it into the box. If /ou don\'t have a Chatwee account yet, please <a target="_blank" style="text-decoration: underline;" href="https://client.chatwee.com/register-form/v2"><b>sign up</b></a> absolutely for free.');

        return $this->textareaTag->render() . $this->infoTag->render();
    }
}